# Generated by Django 5.0.3 on 2024-06-11 09:22

import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='ExpectationObject',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('object_type', models.CharField(choices=[('RAN_SUBNETWORK', 'RAN_SUBNETWORK'), ('EDGE_SERVICE_SUPPORT', 'EDGE_SERVICE_SUPPORT'), ('5GC_SUBNETWORK', '5GC_SUBNETWORK'), ('NEMO_WORKLOAD', 'NEMO_WORKLOAD')], default='NEMO_WORKLOAD', help_text='It describes the expectation object type which can be supported by a specific intent handling function of MnS producer. ', max_length=20)),
                ('object_instance', models.CharField(max_length=256)),
                ('context_selectivity', models.CharField(blank=True, choices=[('ALL_OF', 'ALL_OF'), ('ONE_OF', 'ONE_OF'), ('ANY_OF', 'ANY_OF')], db_index=True, help_text='How to select among the stated expectationContexts', max_length=6, null=True)),
            ],
            options={
                'verbose_name': 'Expectation Object',
                'verbose_name_plural': 'Expectation Objects',
                'db_table': 'expectation_object',
            },
        ),
        migrations.CreateModel(
            name='Intent',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('user_label', models.CharField(help_text='A user-friendly (and user assignable) name of the intent.', max_length=50)),
                ('context_selectivity', models.CharField(blank=True, choices=[('ALL_OF', 'ALL_OF'), ('ONE_OF', 'ONE_OF'), ('ANY_OF', 'ANY_OF')], db_index=True, help_text='How to select among the stated intentContexts', max_length=6, null=True)),
                ('intent_admin_state', models.CharField(choices=[('ACTIVATED', 'ACTIVATED'), ('DEACTIVATED', 'DEACTIVATED')], db_index=True, default='ACTIVATED', help_text='It describes the intent administrative state.  This attribute is used when MnS consumer-suspension mechanism is supported', max_length=11)),
                ('intent_priority', models.PositiveIntegerField(default=1, help_text='It expresses the priority of the stated intent within a MnS consumer')),
                ('intent_preemption_capability', models.CharField(choices=[('TRUE', 'TRUE'), ('FALSE', 'FALSE')], db_index=True, default='FALSE', max_length=5)),
                ('observation_period', models.PositiveIntegerField(default=60, help_text='In seconds')),
            ],
            options={
                'verbose_name': 'Intent',
                'verbose_name_plural': 'Intents',
                'db_table': 'intent',
            },
        ),
        migrations.CreateModel(
            name='TimeWindow',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_time', models.DateTimeField(blank=True, null=True)),
                ('end_time', models.DateTimeField(blank=True, null=True)),
            ],
            options={
                'verbose_name': 'Time Window',
                'verbose_name_plural': 'Time Windows',
                'db_table': 'time_window',
            },
        ),
        migrations.CreateModel(
            name='IntentExpectation',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('expectation_id', models.CharField(help_text='A unique identifier of the intentExpectation within the intent', max_length=256)),
                ('expectation_verb', models.CharField(choices=[('DELIVER', 'DELIVER'), ('ENSURE', 'ENSURE')], db_index=True, default='DELIVER', max_length=7)),
                ('expectation_object', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='intent_expectations', to='intent.expectationobject')),
                ('intent', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='intent_expectations', to='intent.intent')),
            ],
            options={
                'verbose_name': 'Intent Expectation',
                'verbose_name_plural': 'Intent Expectations',
                'db_table': 'intent_expectation',
            },
        ),
        migrations.CreateModel(
            name='ExpectationTarget',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('target_name', models.CharField(max_length=50)),
                ('target_condition', models.CharField(choices=[('IS_EQUAL_TO', 'IS_EQUAL_TO'), ('IS_LESS_THAN', 'IS_LESS_THAN'), ('IS_GREATER_THAN', 'IS_GREATER_THAN'), ('IS_WITHIN_RANGE', 'IS_WITHIN_RANGE'), ('IS_OUTSIDE_RANGE', 'IS_OUTSIDE_RANGE'), ('IS_ONE_OF', 'IS_ONE_OF'), ('IS_NOT_ONE_OF', 'IS_NOT_ONE_OF'), ('IS_EQUAL_TO_OR_LESS_THAN', 'IS_EQUAL_TO_OR_LESS_THAN'), ('IS_EQUAL_TO_OR_GREATER_THAN', 'IS_EQUAL_TO_OR_GREATER_THAN'), ('IS_ALL_OF', 'IS_ALL_OF')], db_index=True, max_length=30)),
                ('intent_expectation', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='expectation_targets', to='intent.intentexpectation')),
            ],
            options={
                'verbose_name': 'Expectation Target',
                'verbose_name_plural': 'Expectation Targets',
                'db_table': 'expectation_target',
            },
        ),
        migrations.CreateModel(
            name='Context',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('context_attribute', models.CharField(max_length=50)),
                ('context_condition', models.CharField(choices=[('IS_EQUAL_TO', 'IS_EQUAL_TO'), ('IS_LESS_THAN', 'IS_LESS_THAN'), ('IS_GREATER_THAN', 'IS_GREATER_THAN'), ('IS_WITHIN_RANGE', 'IS_WITHIN_RANGE'), ('IS_OUTSIDE_RANGE', 'IS_OUTSIDE_RANGE'), ('IS_ONE_OF', 'IS_ONE_OF'), ('IS_NOT_ONE_OF', 'IS_NOT_ONE_OF'), ('IS_EQUAL_TO_OR_LESS_THAN', 'IS_EQUAL_TO_OR_LESS_THAN'), ('IS_EQUAL_TO_OR_GREATER_THAN', 'IS_EQUAL_TO_OR_GREATER_THAN'), ('IS_ALL_OF', 'IS_ALL_OF')], db_index=True, default='IS_EQUAL_TO', max_length=30)),
                ('expectation_object', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='object_contexts', to='intent.expectationobject')),
                ('intent', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='intent_contexts', to='intent.intent')),
                ('intent_expectation', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='expectation_contexts', to='intent.intentexpectation')),
            ],
            options={
                'verbose_name': 'Context',
                'verbose_name_plural': 'Contexts',
                'db_table': 'context',
            },
        ),
        migrations.CreateModel(
            name='TargetValueRange',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('selected_type', models.CharField(choices=[('type_integer', 'type_integer'), ('type_boolean', 'type_boolean'), ('type_string', 'type_string'), ('type_number', 'type_number'), ('type_datetime', 'type_datetime'), ('type_time_window', 'type_time_window')], db_index=True, default='type_string', max_length=50)),
                ('type_integer', models.IntegerField(blank=True, null=True)),
                ('type_boolean', models.BooleanField(blank=True, null=True)),
                ('type_string', models.CharField(blank=True, max_length=256, null=True)),
                ('type_number', models.FloatField(blank=True, null=True)),
                ('type_datetime', models.DateTimeField(blank=True, null=True)),
                ('expectation_object', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='target_value_ranges', to='intent.expectationobject')),
                ('type_time_window', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='intent.timewindow')),
            ],
            options={
                'verbose_name': 'Target Value Range',
                'verbose_name_plural': 'Target Values Ranges',
                'db_table': 'target_value_range',
            },
        ),
        migrations.CreateModel(
            name='ContextValueRange',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('selected_type', models.CharField(choices=[('type_integer', 'type_integer'), ('type_boolean', 'type_boolean'), ('type_string', 'type_string'), ('type_number', 'type_number'), ('type_datetime', 'type_datetime'), ('type_time_window', 'type_time_window')], db_index=True, default='type_string', max_length=50)),
                ('type_integer', models.IntegerField(blank=True, null=True)),
                ('type_boolean', models.BooleanField(blank=True, null=True)),
                ('type_string', models.CharField(blank=True, max_length=256, null=True)),
                ('type_number', models.FloatField(blank=True, null=True)),
                ('type_datetime', models.DateTimeField(blank=True, null=True)),
                ('context', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='context_value_ranges', to='intent.context')),
                ('type_time_window', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='intent.timewindow')),
            ],
            options={
                'verbose_name': 'Context Value Range',
                'verbose_name_plural': 'Context Value Ranges',
                'db_table': 'context_value_range',
            },
        ),
    ]
